openapi: 3.0.1
info:
  title: OpenAPI definition
  version: v0
servers:
- description: Generated server url
  url: http://localhost:8080
paths:
  /locations:
    get:
      description: get-location
      operationId: getCollectionResource-location-get_1
      parameters:
      - description: Zero-based page index (0..N)
        explode: true
        in: query
        name: page
        required: false
        schema:
          default: 0
          minimum: 0
          type: integer
        style: form
      - description: The size of the page to be returned
        explode: true
        in: query
        name: size
        required: false
        schema:
          default: 20
          minimum: 1
          type: integer
        style: form
      - description: "Sorting criteria in the format: property,(asc|desc). Default\
          \ sort order is ascending. Multiple sort criteria are supported."
        explode: true
        in: query
        name: sort
        required: false
        schema:
          items:
            type: string
          type: array
        style: form
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/PagedModelEntityModelLocation'
            application/x-spring-data-compact+json:
              schema:
                $ref: '#/components/schemas/PagedModelEntityModelLocation'
            text/uri-list:
              schema:
                type: string
          description: OK
      tags:
      - location-entity-controller
      x-accepts: "application/hal+json,application/x-spring-data-compact+json,text/uri-list"
    post:
      description: create-location
      operationId: postCollectionResource-location-post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LocationRequestBody'
        required: true
      responses:
        "201":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelLocation'
          description: Created
      tags:
      - location-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
  /locations/search/findByName:
    get:
      operationId: executeSearch-location-get
      parameters:
      - explode: true
        in: query
        name: name
        required: false
        schema:
          type: string
        style: form
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelLocation'
          description: OK
        "404":
          description: Not Found
      tags:
      - location-search-controller
      x-accepts: application/hal+json
  /locations/{id}:
    delete:
      description: delete-location
      operationId: deleteItemResource-location-delete
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "204":
          description: No Content
        "404":
          description: Not Found
      tags:
      - location-entity-controller
      x-accepts: application/json
    get:
      description: get-location
      operationId: getItemResource-location-get
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelLocation'
          description: OK
        "404":
          description: Not Found
      tags:
      - location-entity-controller
      x-accepts: application/hal+json
    patch:
      description: patch-location
      operationId: patchItemResource-location-patch
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LocationRequestBody'
        required: true
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelLocation'
          description: OK
        "204":
          description: No Content
      tags:
      - location-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
    put:
      description: update-location
      operationId: putItemResource-location-put
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LocationRequestBody'
        required: true
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelLocation'
          description: OK
        "201":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelLocation'
          description: Created
        "204":
          description: No Content
      tags:
      - location-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
  /profile:
    get:
      operationId: listAllFormsOfMetadata_1
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/RepresentationModelObject'
          description: OK
      tags:
      - profile-controller
      x-accepts: application/hal+json
  /profile/locations:
    get:
      operationId: descriptor_1_1_1
      responses:
        "200":
          content:
            '*/*':
              schema:
                type: string
            application/alps+json:
              schema:
                type: string
            application/schema+json:
              schema:
                $ref: '#/components/schemas/JsonSchema'
          description: OK
      tags:
      - profile-controller
      x-accepts: "*/*,application/alps+json,application/schema+json"
  /profile/transportCalls:
    get:
      operationId: descriptor_1_1_2
      responses:
        "200":
          content:
            '*/*':
              schema:
                type: string
            application/alps+json:
              schema:
                type: string
            application/schema+json:
              schema:
                $ref: '#/components/schemas/JsonSchema'
          description: OK
      tags:
      - profile-controller
      x-accepts: "*/*,application/alps+json,application/schema+json"
  /profile/transports:
    get:
      operationId: descriptor_1_1_3
      responses:
        "200":
          content:
            '*/*':
              schema:
                type: string
            application/alps+json:
              schema:
                type: string
            application/schema+json:
              schema:
                $ref: '#/components/schemas/JsonSchema'
          description: OK
      tags:
      - profile-controller
      x-accepts: "*/*,application/alps+json,application/schema+json"
  /profile/vehicles:
    get:
      operationId: descriptor_1_1_4
      responses:
        "200":
          content:
            '*/*':
              schema:
                type: string
            application/alps+json:
              schema:
                type: string
            application/schema+json:
              schema:
                $ref: '#/components/schemas/JsonSchema'
          description: OK
      tags:
      - profile-controller
      x-accepts: "*/*,application/alps+json,application/schema+json"
  /transportCalls:
    get:
      description: get-transportcall
      operationId: getCollectionResource-transportcall-get_1
      parameters:
      - description: Zero-based page index (0..N)
        explode: true
        in: query
        name: page
        required: false
        schema:
          default: 0
          minimum: 0
          type: integer
        style: form
      - description: The size of the page to be returned
        explode: true
        in: query
        name: size
        required: false
        schema:
          default: 20
          minimum: 1
          type: integer
        style: form
      - description: "Sorting criteria in the format: property,(asc|desc). Default\
          \ sort order is ascending. Multiple sort criteria are supported."
        explode: true
        in: query
        name: sort
        required: false
        schema:
          items:
            type: string
          type: array
        style: form
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/PagedModelEntityModelTransportCall'
            application/x-spring-data-compact+json:
              schema:
                $ref: '#/components/schemas/PagedModelEntityModelTransportCall'
            text/uri-list:
              schema:
                type: string
          description: OK
      tags:
      - transport-call-entity-controller
      x-accepts: "application/hal+json,application/x-spring-data-compact+json,text/uri-list"
    post:
      description: create-transportcall
      operationId: postCollectionResource-transportcall-post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TransportCallRequestBody'
        required: true
      responses:
        "201":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransportCall'
          description: Created
      tags:
      - transport-call-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
  /transportCalls/{id}:
    delete:
      description: delete-transportcall
      operationId: deleteItemResource-transportcall-delete
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "204":
          description: No Content
        "404":
          description: Not Found
      tags:
      - transport-call-entity-controller
      x-accepts: application/json
    get:
      description: get-transportcall
      operationId: getItemResource-transportcall-get
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransportCall'
          description: OK
        "404":
          description: Not Found
      tags:
      - transport-call-entity-controller
      x-accepts: application/hal+json
    patch:
      description: patch-transportcall
      operationId: patchItemResource-transportcall-patch
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TransportCallRequestBody'
        required: true
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransportCall'
          description: OK
        "204":
          description: No Content
      tags:
      - transport-call-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
    put:
      description: update-transportcall
      operationId: putItemResource-transportcall-put
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TransportCallRequestBody'
        required: true
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransportCall'
          description: OK
        "201":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransportCall'
          description: Created
        "204":
          description: No Content
      tags:
      - transport-call-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
  /transports:
    get:
      description: get-transport
      operationId: getCollectionResource-transport-get_1
      parameters:
      - description: Zero-based page index (0..N)
        explode: true
        in: query
        name: page
        required: false
        schema:
          default: 0
          minimum: 0
          type: integer
        style: form
      - description: The size of the page to be returned
        explode: true
        in: query
        name: size
        required: false
        schema:
          default: 20
          minimum: 1
          type: integer
        style: form
      - description: "Sorting criteria in the format: property,(asc|desc). Default\
          \ sort order is ascending. Multiple sort criteria are supported."
        explode: true
        in: query
        name: sort
        required: false
        schema:
          items:
            type: string
          type: array
        style: form
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/PagedModelEntityModelTransport'
            application/x-spring-data-compact+json:
              schema:
                $ref: '#/components/schemas/PagedModelEntityModelTransport'
            text/uri-list:
              schema:
                type: string
          description: OK
      tags:
      - transport-entity-controller
      x-accepts: "application/hal+json,application/x-spring-data-compact+json,text/uri-list"
    post:
      description: create-transport
      operationId: postCollectionResource-transport-post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TransportRequestBody'
        required: true
      responses:
        "201":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransport'
          description: Created
      tags:
      - transport-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
  /transports/{id}:
    delete:
      description: delete-transport
      operationId: deleteItemResource-transport-delete
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "204":
          description: No Content
        "404":
          description: Not Found
      tags:
      - transport-entity-controller
      x-accepts: application/json
    get:
      description: get-transport
      operationId: getItemResource-transport-get
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransport'
          description: OK
        "404":
          description: Not Found
      tags:
      - transport-entity-controller
      x-accepts: application/hal+json
    patch:
      description: patch-transport
      operationId: patchItemResource-transport-patch
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TransportRequestBody'
        required: true
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransport'
          description: OK
        "204":
          description: No Content
      tags:
      - transport-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
    put:
      description: update-transport
      operationId: putItemResource-transport-put
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TransportRequestBody'
        required: true
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransport'
          description: OK
        "201":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelTransport'
          description: Created
        "204":
          description: No Content
      tags:
      - transport-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
  /vehicles:
    get:
      description: get-vehicle
      operationId: getCollectionResource-vehicle-get_1
      parameters:
      - description: Zero-based page index (0..N)
        explode: true
        in: query
        name: page
        required: false
        schema:
          default: 0
          minimum: 0
          type: integer
        style: form
      - description: The size of the page to be returned
        explode: true
        in: query
        name: size
        required: false
        schema:
          default: 20
          minimum: 1
          type: integer
        style: form
      - description: "Sorting criteria in the format: property,(asc|desc). Default\
          \ sort order is ascending. Multiple sort criteria are supported."
        explode: true
        in: query
        name: sort
        required: false
        schema:
          items:
            type: string
          type: array
        style: form
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/PagedModelEntityModelVehicle'
            application/x-spring-data-compact+json:
              schema:
                $ref: '#/components/schemas/PagedModelEntityModelVehicle'
            text/uri-list:
              schema:
                type: string
          description: OK
      tags:
      - vehicle-entity-controller
      x-accepts: "application/hal+json,application/x-spring-data-compact+json,text/uri-list"
    post:
      description: create-vehicle
      operationId: postCollectionResource-vehicle-post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/VehicleRequestBody'
        required: true
      responses:
        "201":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelVehicle'
          description: Created
      tags:
      - vehicle-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
  /vehicles/search/findByImoNumber:
    get:
      operationId: executeSearch-vehicle-get
      parameters:
      - explode: true
        in: query
        name: imoNumber
        required: false
        schema:
          type: string
        style: form
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelVehicle'
          description: OK
        "404":
          description: Not Found
      tags:
      - vehicle-search-controller
      x-accepts: application/hal+json
  /vehicles/{id}:
    delete:
      description: delete-vehicle
      operationId: deleteItemResource-vehicle-delete
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "204":
          description: No Content
        "404":
          description: Not Found
      tags:
      - vehicle-entity-controller
      x-accepts: application/json
    get:
      description: get-vehicle
      operationId: getItemResource-vehicle-get
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelVehicle'
          description: OK
        "404":
          description: Not Found
      tags:
      - vehicle-entity-controller
      x-accepts: application/hal+json
    patch:
      description: patch-vehicle
      operationId: patchItemResource-vehicle-patch
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/VehicleRequestBody'
        required: true
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelVehicle'
          description: OK
        "204":
          description: No Content
      tags:
      - vehicle-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
    put:
      description: update-vehicle
      operationId: putItemResource-vehicle-put
      parameters:
      - explode: false
        in: path
        name: id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/VehicleRequestBody'
        required: true
      responses:
        "200":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelVehicle'
          description: OK
        "201":
          content:
            application/hal+json:
              schema:
                $ref: '#/components/schemas/EntityModelVehicle'
          description: Created
        "204":
          description: No Content
      tags:
      - vehicle-entity-controller
      x-content-type: application/json
      x-accepts: application/hal+json
components:
  schemas:
    AbstractJsonSchemaPropertyObject:
      properties:
        title:
          type: string
        readOnly:
          type: boolean
      type: object
    Item:
      properties:
        type:
          type: string
        properties:
          additionalProperties:
            $ref: '#/components/schemas/AbstractJsonSchemaPropertyObject'
          type: object
        requiredProperties:
          items:
            type: string
          type: array
      type: object
    JsonSchema:
      properties:
        title:
          type: string
        description:
          type: string
        properties:
          additionalProperties:
            $ref: '#/components/schemas/AbstractJsonSchemaPropertyObject'
          type: object
        requiredProperties:
          items:
            type: string
          type: array
        definitions:
          additionalProperties:
            $ref: '#/components/schemas/Item'
          type: object
        type:
          type: string
        $schema:
          type: string
      type: object
    Links:
      additionalProperties:
        $ref: '#/components/schemas/Link'
      type: object
    RepresentationModelObject:
      properties:
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
      type: object
    Vehicle:
      example:
        imoNumber: imoNumber
        name: name
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
      properties:
        id:
          format: uuid
          type: string
        imoNumber:
          type: string
        name:
          type: string
      type: object
    EntityModelVehicle:
      properties:
        imoNumber:
          type: string
        name:
          type: string
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
      type: object
    PageMetadata:
      properties:
        size:
          format: int64
          type: integer
        totalElements:
          format: int64
          type: integer
        totalPages:
          format: int64
          type: integer
        number:
          format: int64
          type: integer
      type: object
    PagedModelEntityModelVehicle:
      properties:
        _embedded:
          $ref: '#/components/schemas/PagedModelEntityModelVehicle__embedded'
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
        page:
          $ref: '#/components/schemas/PageMetadata'
      type: object
    EntityModelLocation:
      properties:
        name:
          type: string
        locode:
          type: string
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
      type: object
    PagedModelEntityModelLocation:
      properties:
        _embedded:
          $ref: '#/components/schemas/PagedModelEntityModelLocation__embedded'
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
        page:
          $ref: '#/components/schemas/PageMetadata'
      type: object
    EntityModelTransport:
      properties:
        vehicle:
          $ref: '#/components/schemas/Vehicle'
        mode:
          enum:
          - OCEAN
          type: string
        arrivalPortCallId:
          format: uuid
          type: string
        destinationPortCallId:
          format: uuid
          type: string
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
      type: object
    PagedModelEntityModelTransport:
      properties:
        _embedded:
          $ref: '#/components/schemas/PagedModelEntityModelTransport__embedded'
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
        page:
          $ref: '#/components/schemas/PageMetadata'
      type: object
    EntityModelTransportCall:
      properties:
        locationId:
          format: uuid
          type: string
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
      type: object
    PagedModelEntityModelTransportCall:
      properties:
        _embedded:
          $ref: '#/components/schemas/PagedModelEntityModelTransportCall__embedded'
        _links:
          additionalProperties:
            $ref: '#/components/schemas/Link'
          type: object
        page:
          $ref: '#/components/schemas/PageMetadata'
      type: object
    LocationRequestBody:
      example:
        locode: locode
        name: name
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
      properties:
        id:
          format: uuid
          type: string
        name:
          type: string
        locode:
          type: string
      type: object
    TransportCallRequestBody:
      example:
        locationId: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
      properties:
        id:
          format: uuid
          type: string
        locationId:
          format: uuid
          type: string
      type: object
    TransportRequestBody:
      example:
        mode: OCEAN
        destinationPortCallId: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        arrivalPortCallId: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        vehicle:
          imoNumber: imoNumber
          name: name
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
      properties:
        id:
          format: uuid
          type: string
        vehicle:
          $ref: '#/components/schemas/Vehicle'
        mode:
          enum:
          - OCEAN
          type: string
        arrivalPortCallId:
          format: uuid
          type: string
        destinationPortCallId:
          format: uuid
          type: string
      type: object
    VehicleRequestBody:
      example:
        imoNumber: imoNumber
        name: name
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
      properties:
        id:
          format: uuid
          type: string
        imoNumber:
          type: string
        name:
          type: string
      type: object
    Link:
      properties:
        href:
          type: string
        hreflang:
          type: string
        title:
          type: string
        type:
          type: string
        deprecation:
          type: string
        profile:
          type: string
        name:
          type: string
        templated:
          type: boolean
      type: object
    PagedModelEntityModelVehicle__embedded:
      properties:
        vehicles:
          items:
            $ref: '#/components/schemas/EntityModelVehicle'
          type: array
      type: object
    PagedModelEntityModelLocation__embedded:
      properties:
        locations:
          items:
            $ref: '#/components/schemas/EntityModelLocation'
          type: array
      type: object
    PagedModelEntityModelTransport__embedded:
      properties:
        transports:
          items:
            $ref: '#/components/schemas/EntityModelTransport'
          type: array
      type: object
    PagedModelEntityModelTransportCall__embedded:
      properties:
        transportCalls:
          items:
            $ref: '#/components/schemas/EntityModelTransportCall'
          type: array
      type: object

